
unit MinHook;
interface

uses Windows;
{$calling stdcall}

{
  Automatically converted by H2Pas 1.0.0 from MinHook.h
  The following command line parameters were used:
    -w
    MinHook.h
}



//{$DEFINE STATIC_MINHOOK}

{$ifdef STATIC_MINHOOK}
    {$LINKLIB minhook_x86}
{$else}
const
    External_library='MinHook_x86'; {Setup as you need}
{$endif}

{$IFDEF FPC}
{$PACKRECORDS C}
{$ENDIF}


  {
   *  MinHook - The Minimalistic API Hooking Library for x64/x86
   *  Copyright (C) 2009-2017 Tsuda Kageyu.
   *  All rights reserved.
   *
   *  Redistribution and use in source and binary forms, with or without
   *  modification, are permitted provided that the following conditions
   *  are met:
   *
   *   1. Redistributions of source code must retain the above copyright
   *      notice, this list of conditions and the following disclaimer.
   *   2. Redistributions in binary form must reproduce the above copyright
   *      notice, this list of conditions and the following disclaimer in the
   *      documentation and/or other materials provided with the distribution.
   *
   *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
   *  TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
   *  PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER
   *  OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
   *  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
   *  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
   *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
   *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
   *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
   *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
    }
(** unsupported pragma#pragma once*)
//{$if !(defined _M_IX86) && !(defined _M_X64) && !(defined __i386__) && !(defined __x86_64__)}
//{$error MinHook supports only x86 and x64 systems.}
//{$endif}
//{$include <windows.h>}
  { MinHook Error Codes. }
  { Unknown error. Should not be returned. }
  { Successful. }
  { MinHook is already initialized. }
  { MinHook is not initialized yet, or already uninitialized. }
  { The hook for the specified target function is already created. }
  { The hook for the specified target function is not created yet. }
  { The hook for the specified target function is already enabled. }
  { The hook for the specified target function is not enabled yet, or already }
  { disabled. }
  { The specified pointer is invalid. It points the address of non-allocated }
  { and/or non-executable region. }
  { The specified target function cannot be hooked. }
  { Failed to allocate memory. }
  { Failed to change the memory protection. }
  { The specified module is not loaded. }
  { The specified function is not found. }

  type
    MH_STATUS = (MH_UNKNOWN := -(1),MH_OK := 0,MH_ERROR_ALREADY_INITIALIZED,
      MH_ERROR_NOT_INITIALIZED,MH_ERROR_ALREADY_CREATED,
      MH_ERROR_NOT_CREATED,MH_ERROR_ENABLED,
      MH_ERROR_DISABLED,MH_ERROR_NOT_EXECUTABLE,
      MH_ERROR_UNSUPPORTED_FUNCTION,MH_ERROR_MEMORY_ALLOC,
      MH_ERROR_MEMORY_PROTECT,MH_ERROR_MODULE_NOT_FOUND,
      MH_ERROR_FUNCTION_NOT_FOUND);
  { Can be passed as a parameter to MH_EnableHook, MH_DisableHook, }
  { MH_QueueEnableHook or MH_QueueDisableHook. }

  const
    MH_ALL_HOOKS = nil;    
{ C++ extern C conditionnal removed }
  { Initialize the MinHook library. You must call this function EXACTLY ONCE }
  { at the beginning of your program. }

  function MH_Initialize:MH_STATUS;external {$ifndef STATIC_MINHOOK}External_library{$endif} name 'MH_Initialize';

  { Uninitialize the MinHook library. You must call this function EXACTLY }
  { ONCE at the end of your program. }
  function MH_Uninitialize:MH_STATUS;external {$ifndef STATIC_MINHOOK}External_library{$endif} name 'MH_Uninitialize';

  { Creates a Hook for the specified target function, in disabled state. }
  { Parameters: }
  {   pTarget    [in]  A pointer to the target function, which will be }
  {                    overridden by the detour function. }
  {   pDetour    [in]  A pointer to the detour function, which will override }
  {                    the target function. }
  {   ppOriginal [out] A pointer to the trampoline function, which will be }
  {                    used to call the original target function. }
  {                    This parameter can be NULL. }
  function MH_CreateHook(pTarget:LPVOID; pDetour:LPVOID; out ppOriginal:LPVOID):MH_STATUS; external {$ifndef STATIC_MINHOOK}External_library{$endif} name 'MH_CreateHook';

  { Creates a Hook for the specified API function, in disabled state. }
  { Parameters: }
  {   pszModule  [in]  A pointer to the loaded module name which contains the }
  {                    target function. }
  {   pszTarget  [in]  A pointer to the target function name, which will be }
  {                    overridden by the detour function. }
  {   pDetour    [in]  A pointer to the detour function, which will override }
  {                    the target function. }
  {   ppOriginal [out] A pointer to the trampoline function, which will be }
  {                    used to call the original target function. }
  {                    This parameter can be NULL. }
  function MH_CreateHookApi(pszModule:LPCWSTR; pszProcName:LPCSTR; pDetour:LPVOID; out ppOriginal:LPVOID):MH_STATUS;external {$ifndef STATIC_MINHOOK}External_library{$endif} name 'MH_CreateHookApi';

  { Creates a Hook for the specified API function, in disabled state. }
  { Parameters: }
  {   pszModule  [in]  A pointer to the loaded module name which contains the }
  {                    target function. }
  {   pszTarget  [in]  A pointer to the target function name, which will be }
  {                    overridden by the detour function. }
  {   pDetour    [in]  A pointer to the detour function, which will override }
  {                    the target function. }
  {   ppOriginal [out] A pointer to the trampoline function, which will be }
  {                    used to call the original target function. }
  {                    This parameter can be NULL. }
  {   ppTarget   [out] A pointer to the target function, which will be used }
  {                    with other functions. }
  {                    This parameter can be NULL. }
  function MH_CreateHookApiEx(pszModule:LPCWSTR; pszProcName:LPCSTR; pDetour:LPVOID; out ppOriginal:LPVOID; out ppTarget:LPVOID):MH_STATUS;external {$ifndef STATIC_MINHOOK}External_library{$endif} name 'MH_CreateHookApiEx';

  { Removes an already created hook. }
  { Parameters: }
  {   pTarget [in] A pointer to the target function. }
  function MH_RemoveHook(pTarget:LPVOID):MH_STATUS;external {$ifndef STATIC_MINHOOK}External_library{$endif} name 'MH_RemoveHook';

  { Enables an already created hook. }
  { Parameters: }
  {   pTarget [in] A pointer to the target function. }
  {                If this parameter is MH_ALL_HOOKS, all created hooks are }
  {                enabled in one go. }
  function MH_EnableHook(pTarget:LPVOID):MH_STATUS;external {$ifndef STATIC_MINHOOK}External_library{$endif} name 'MH_EnableHook';

  { Disables an already created hook. }
  { Parameters: }
  {   pTarget [in] A pointer to the target function. }
  {                If this parameter is MH_ALL_HOOKS, all created hooks are }
  {                disabled in one go. }
  function MH_DisableHook(pTarget:LPVOID):MH_STATUS;external {$ifndef STATIC_MINHOOK}External_library{$endif} name 'MH_DisableHook';

  { Queues to enable an already created hook. }
  { Parameters: }
  {   pTarget [in] A pointer to the target function. }
  {                If this parameter is MH_ALL_HOOKS, all created hooks are }
  {                queued to be enabled. }
  function MH_QueueEnableHook(pTarget:LPVOID):MH_STATUS;external {$ifndef STATIC_MINHOOK}External_library{$endif} name 'MH_QueueEnableHook';

  { Queues to disable an already created hook. }
  { Parameters: }
  {   pTarget [in] A pointer to the target function. }
  {                If this parameter is MH_ALL_HOOKS, all created hooks are }
  {                queued to be disabled. }
  function MH_QueueDisableHook(pTarget:LPVOID):MH_STATUS;external {$ifndef STATIC_MINHOOK}External_library{$endif} name 'MH_QueueDisableHook';

  { Applies all queued changes in one go. }
  function MH_ApplyQueued:MH_STATUS;external {$ifndef STATIC_MINHOOK}External_library{$endif} name 'MH_ApplyQueued';

  { Translates the MH_STATUS to its name as a string. }
(* Const before type ignored *)
(* error 
    const char * WINAPI MH_StatusToString(MH_STATUS status);
 in declarator_list *)
{ C++ end of extern C conditionnal removed }

implementation

end.
